Index: java/main/src/main/java/com/framsticks/gui/ModifiablePanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/ModifiablePanel.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/ModifiablePanel.java	(revision 100)
@@ -1,5 +1,6 @@
 package com.framsticks.gui;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 
@@ -13,7 +14,7 @@
  */
 @SuppressWarnings("serial")
-public abstract class ModifiablePanel extends Panel {
+public abstract class ModifiablePanel extends TreePanel {
 
-	private static final Logger log = Logger.getLogger(ModifiablePanel.class.getName());
+	private static final Logger log = LogManager.getLogger(ModifiablePanel.class.getName());
 
 	/**
@@ -27,7 +28,7 @@
 	protected Component contentComponent;
 
-	public ModifiablePanel(Panel.Parameters parameters) {
+	public ModifiablePanel(TreePanel.Parameters parameters) {
 		super(parameters);
-		log.debug("create panel for type: " + className);
+		log.debug("create panel for type: {}", className);
 
 
Index: java/main/src/main/java/com/framsticks/gui/MultiPanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/MultiPanel.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/MultiPanel.java	(revision 100)
@@ -1,8 +1,8 @@
 package com.framsticks.gui;
 
-import com.framsticks.params.AccessInterface;
+import com.framsticks.core.Path;
+import com.framsticks.params.Access;
 
 import javax.swing.*;
-import javax.swing.tree.TreePath;
 
 import java.awt.*;
@@ -13,16 +13,16 @@
  */
 @SuppressWarnings("serial")
-public class MultiPanel extends Panel {
+public class MultiPanel extends TreePanel {
 
-	protected final List<Panel> panels;
+	protected final List<TreePanel> panels;
 	protected final JTabbedPane tabbedPane;
 
 
-	public MultiPanel(Panel.Parameters parameters, List<Panel> panels) {
+	public MultiPanel(TreePanel.Parameters parameters, List<TreePanel> panels) {
 		super(parameters);
 		this.panels = panels;
 		tabbedPane = new JTabbedPane();
 
-		for (Panel p : panels) {
+		for (TreePanel p : panels) {
 			assert p.getClassName().equals(getClassName());
 			assert p.getTreeAtFrame() == getTreeAtFrame();
@@ -36,6 +36,6 @@
 
 	@Override
-	public void pullValuesFromLocalToUser(AccessInterface access) {
-		for (Panel p : panels) {
+	public void pullValuesFromLocalToUser(Access access) {
+		for (TreePanel p : panels) {
 			p.pullValuesFromLocalToUser(access);
 		}
@@ -48,8 +48,8 @@
 
 	@Override
-	public void setCurrentTreePath(TreePath currentTreePath) {
-		super.setCurrentTreePath(currentTreePath);
-		for (Panel p : panels) {
-			p.setCurrentTreePath(currentTreePath);
+	public void setCurrentPath(Path currentPath) {
+		super.setCurrentPath(currentPath);
+		for (TreePanel p : panels) {
+			p.setCurrentPath(currentPath);
 		}
 	}
Index: java/main/src/main/java/com/framsticks/gui/NodeAtFrame.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/NodeAtFrame.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/NodeAtFrame.java	(revision 100)
@@ -8,7 +8,11 @@
 public class NodeAtFrame {
 
-	protected Panel panel;
-
 	protected final Map<ValueControl, Object> localChanges = new IdentityHashMap<>();
 
+	/**
+	 *
+	 */
+	public NodeAtFrame() {
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/gui/ObjectPanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/ObjectPanel.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/ObjectPanel.java	(revision 100)
@@ -1,16 +1,17 @@
 package com.framsticks.gui;
 
+import com.framsticks.core.Path;
 import com.framsticks.gui.controls.Control;
 import com.framsticks.gui.controls.ControlOwner;
 import com.framsticks.gui.controls.ValueControl;
 import com.framsticks.gui.controls.ValueControlListener;
-import com.framsticks.params.AccessInterface;
+import com.framsticks.params.Access;
 import com.framsticks.params.Param;
 import com.framsticks.params.ValueParam;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import javax.swing.*;
-import javax.swing.tree.TreePath;
 
 import java.util.Collection;
@@ -24,5 +25,5 @@
 public class ObjectPanel extends ModifiablePanel implements ControlOwner {
 
-	private static final Logger log = Logger.getLogger(ObjectPanel.class);
+	private static final Logger log = LogManager.getLogger(ObjectPanel.class);
 
 	final protected Map<Param, Control> components = new IdentityHashMap<Param, Control>();
@@ -32,5 +33,5 @@
 	protected final JScrollPane scrollPane;
 
-	public ObjectPanel(Panel.Parameters parameters, Collection<Param> params) {
+	public ObjectPanel(TreePanel.Parameters parameters, Collection<Param> params) {
 		super(parameters);
 
@@ -49,8 +50,8 @@
 				@Override
 				public boolean onChange(Object newValue) {
-					if (currentTreePath == null) {
+					if (currentPath == null) {
 						return true;
 					}
-					boolean result = treeAtFrame.changeValue(currentTreePath, c, newValue);
+					boolean result = treeAtFrame.changeValue(currentPath.assureResolved().getTopObject(), c, newValue);
 					refreshControlButtons();
 					return result;
@@ -66,19 +67,16 @@
 	protected void applyChanges() {
 		assert frame.isActive();
-		assert currentTreePath != null;
-		treeAtFrame.pushLocalChanges(currentTreePath);
+		assert currentPath != null;
+		treeAtFrame.pushLocalChanges(currentPath);
 	}
 
 	protected void refreshControlButtons() {
 		assert frame.isActive();
-		applyButton.setEnabled(treeAtFrame.hasLocalChanges(currentTreePath));
-	}
-
-	protected static void fillControlsWithValues(Map<ValueControl, Object> map) {
+		applyButton.setEnabled(treeAtFrame.hasLocalChanges(currentPath.getTopObject()));
 	}
 
 	@Override
-	public void pullValuesFromLocalToUser(AccessInterface access) {
-		assert currentTreePath != null;
+	public void pullValuesFromLocalToUser(Access access) {
+		assert currentPath != null;
 		log.debug("refreshing components");
 
@@ -89,5 +87,5 @@
 
 
-		NodeAtFrame nodeAtFrame = treeAtFrame.getLocalInfo(currentTreePath);
+		NodeAtFrame nodeAtFrame = treeAtFrame.getLocalInfo(currentPath.getTopObject());
 		if (nodeAtFrame != null) {
 			for (Map.Entry<ValueControl, Object> e : nodeAtFrame.localChanges.entrySet()) {
@@ -120,8 +118,7 @@
 
 	@Override
-	public TreePath getCurrentTreePath() {
-		return super.getCurrentTreePath();
+	public Path getCurrentPath() {
+		return super.getCurrentPath();
 	}
 
-
 }
Index: java/main/src/main/java/com/framsticks/gui/PanelProvider.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/PanelProvider.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/PanelProvider.java	(revision 100)
@@ -6,4 +6,4 @@
  */
 public interface PanelProvider {
-	public Panel providePanel(Panel.Parameters parameters);
+	public TreePanel providePanel(TreePanel.Parameters parameters);
 }
Index: java/main/src/main/java/com/framsticks/gui/StandardPanelProvider.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/StandardPanelProvider.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/StandardPanelProvider.java	(revision 100)
@@ -17,5 +17,5 @@
 	@SuppressWarnings("unchecked")
 	@Override
-	public Panel providePanel(Panel.Parameters parameters) {
+	public TreePanel providePanel(TreePanel.Parameters parameters) {
 		if (parameters.param instanceof ObjectParam) {
 			return new ObjectPanel(parameters, CollectionUtils.select(parameters.framsClass.getParamEntries(), new NotPredicate(new InstanceofPredicate(CompositeParam.class))));
Index: java/main/src/main/java/com/framsticks/gui/StatusBar.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/StatusBar.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/StatusBar.java	(revision 100)
@@ -9,5 +9,6 @@
 import javax.swing.JTextField;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import com.framsticks.gui.controls.Control;
@@ -18,5 +19,5 @@
 
 public class StatusBar implements ExceptionResultHandler, Dispatcher<StatusBar> {
-	private static final Logger log = Logger.getLogger(StatusBar.class);
+	private static final Logger log = LogManager.getLogger(StatusBar.class);
 
 	protected JTextField statusBar;
@@ -36,5 +37,5 @@
 			@Override
 			protected void runAt() {
-				log.error("error: ", exception);
+				log.error("error: {}", exception.getMessage());
 				statusBar.setText(exception.getShortMessage(new StringBuilder()).toString());
 				if (exceptionHandler != null) {
Index: java/main/src/main/java/com/framsticks/gui/TreeAtFrame.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/TreeAtFrame.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/TreeAtFrame.java	(revision 100)
@@ -1,5 +1,6 @@
 package com.framsticks.gui;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import com.framsticks.core.Tree;
@@ -8,5 +9,4 @@
 import com.framsticks.core.TreeOperations;
 import com.framsticks.gui.controls.ValueControl;
-import com.framsticks.gui.tree.TreeNode;
 import com.framsticks.params.CompositeParam;
 import com.framsticks.params.FramsClass;
@@ -14,9 +14,7 @@
 import java.util.*;
 
-import javax.swing.tree.TreePath;
 
 
 import com.framsticks.util.dispatching.FutureHandler;
-import com.framsticks.util.lang.Casting;
 
 /**
@@ -25,12 +23,10 @@
 public class TreeAtFrame {
 
-	private static final Logger log = Logger.getLogger(TreeAtFrame.class);
+	private static final Logger log = LogManager.getLogger(TreeAtFrame.class);
 
 	protected final Frame frame;
 	protected final Tree tree;
-	protected final Map<String, Panel> knownPanels = new HashMap<String, Panel>();
+	protected final Map<String, TreePanel> knownPanels = new HashMap<>();
 	protected Node rootNode;
-
-	protected Map<TreeNode, NodeAtFrame> nodesStorage = new WeakHashMap<>();
 
 	public TreeAtFrame(Tree tree, Frame frame) {
@@ -50,35 +46,22 @@
 	}
 
-	public void registerPanel(Panel panel) {
-	}
-
-	public Panel findPanel(String accessId) {
-		assert frame.isActive();
-		return (knownPanels.containsKey(accessId) ? knownPanels.get(accessId) : null);
-	}
-
 	public final String getName() {
 		return tree.getName();
 	}
 
-	public Panel preparePanel(CompositeParam param, FramsClass framsClass) {
+	public TreePanel preparePanel(final CompositeParam param) {
 		assert frame.isActive();
-		Panel panel = preparePanelImpl(param, framsClass);
-		assert panel != null;
-		String accessId = param.computeAccessId();
-		panel.uniqueName = accessId + "@" + tree.getName();
-		knownPanels.put(accessId, panel);
-		frame.cardPanel.add(panel, panel.uniqueName);
-		log.debug("prepared panel for " + panel);
-		return panel;
-	}
 
-	protected Panel preparePanelImpl(CompositeParam param, FramsClass framsClass) {
-		assert frame.isActive();
-		List<Panel> panels = new ArrayList<Panel>();
+		TreePanel panel = knownPanels.get(param.getFramsTypeName());
+		if (panel != null) {
+			return panel;
+		}
 
-		Panel.Parameters parameters = new Panel.Parameters(this, param, framsClass);
+		final FramsClass framsClass = tree.getInfoFromCache(param.getContainedTypeName());
+		final List<TreePanel> panels = new ArrayList<TreePanel>();
+
+		final TreePanel.Parameters parameters = new TreePanel.Parameters(this, param, framsClass);
 		for (PanelProvider pp : frame.browser.panelProviders) {
-			Panel p = pp.providePanel(parameters);
+			TreePanel p = pp.providePanel(parameters);
 			if (p != null) {
 				panels.add(p);
@@ -87,15 +70,20 @@
 
 		if (panels.isEmpty()) {
-			return new EmptyPanel(parameters);
+			panel = new EmptyTreePanel(parameters);
+		} else 	if (panels.size() == 1) {
+			panel = panels.get(0);
+		} else {
+			panel = new MultiPanel(parameters, panels);
 		}
-		if (panels.size() == 1) {
-			return panels.get(0);
-		}
-		return new MultiPanel(parameters, panels);
 
+		knownPanels.put(param.getFramsTypeName(), panel);
+
+		log.debug("prepared panel for {}", panel);
+		return panel;
 	}
 
-	public boolean hasLocalChanges(TreePath treePath) {
-		NodeAtFrame nodeAtFrame = nodesStorage.get(treePath.getLastPathComponent());
+
+	public boolean hasLocalChanges(Object object) {
+		NodeAtFrame nodeAtFrame = tree.getSideNote(object, this, NodeAtFrame.class);
 		if (nodeAtFrame == null) {
 			return false;
@@ -104,36 +92,36 @@
 	}
 
-	public NodeAtFrame assureLocalInfo(TreePath treePath) {
+	public NodeAtFrame assureLocalInfo(Object object) {
 		assert frame.isActive();
-		NodeAtFrame nodeAtFrame = nodesStorage.get(treePath.getLastPathComponent());
+		NodeAtFrame nodeAtFrame = tree.getSideNote(object, this, NodeAtFrame.class);
 
 		if (nodeAtFrame == null) {
 			nodeAtFrame = new NodeAtFrame();
-			nodesStorage.put(Casting.throwCast(TreeNode.class, treePath.getLastPathComponent()), nodeAtFrame);
+			// log.debug();
+			tree.putSideNote(object, this, nodeAtFrame);
 		}
 		return nodeAtFrame;
 	}
 
-	public NodeAtFrame getLocalInfo(TreePath treePath) {
-		return nodesStorage.get(treePath.getLastPathComponent());
+	public NodeAtFrame getLocalInfo(Object object) {
+		return tree.getSideNote(object, this, NodeAtFrame.class);
 	}
 
-	public boolean changeValue(TreePath treePath, ValueControl component, Object newValue) {
-		log.debug("changing value of " + component + " to '" + newValue + "'");
+	public boolean changeValue(Object object, ValueControl component, Object newValue) {
+		log.debug("changing value of {} to '{}'", component, newValue);
 
-		assureLocalInfo(treePath).localChanges.put(component, newValue);
+		assureLocalInfo(object).localChanges.put(component, newValue);
 
 		return true;
 	}
 
-	public void pushLocalChanges(TreePath treePath) {
+	public void pushLocalChanges(Path path) {
 		assert frame.isActive();
+		path.assureResolved();
 
-		NodeAtFrame nodeAtFrame = nodesStorage.get(treePath.getLastPathComponent());
+		NodeAtFrame nodeAtFrame = getLocalInfo(path.getTopObject());
 		if (nodeAtFrame == null) {
 			return;
 		}
-		Path path = frame.treeModel.convertToPath(treePath);
-
 		for (Map.Entry<ValueControl, Object> e : nodeAtFrame.localChanges.entrySet()) {
 			TreeOperations.set(path, e.getKey().getParam(), e.getValue(), new FutureHandler<Integer>(frame) {
@@ -145,39 +133,3 @@
 	}
 
-	public void fillPanelWithValues(TreePath treePath) {
-		NodeAtFrame nodeAtFrame = assureLocalInfo(treePath);
-		if (nodeAtFrame == null) {
-			return;
-		}
-
-		if (nodeAtFrame.panel == null) {
-			return;
-		}
-		Node node = TreeNode.tryGetNode(treePath);
-		if (node == null) {
-			return;
-		}
-		nodeAtFrame.panel.setCurrentTreePath(treePath);
-		nodeAtFrame.panel.pullValuesFromLocalToUser(TreeOperations.bindAccess(node));
-
-		frame.showPanel(nodeAtFrame.panel);
-
-	}
-
-	public void useOrCreatePanel(TreePath treePath) {
-		// node.assureResolved();
-		Node node = TreeNode.tryGetNode(treePath);
-
-		NodeAtFrame nodeAtFrame = assureLocalInfo(treePath);
-
-		if (nodeAtFrame.panel == null) {
-			CompositeParam param = node.getParam();
-			nodeAtFrame.panel = findPanel(param.computeAccessId());
-			if (nodeAtFrame.panel == null) {
-				FramsClass framsClass = node.getTree().getInfoFromCache(param.getContainedTypeName());
-				nodeAtFrame.panel = preparePanel(param, framsClass);
-			}
-		}
-		fillPanelWithValues(treePath);
-	}
 }
Index: java/main/src/main/java/com/framsticks/gui/TreePanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/TreePanel.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/TreePanel.java	(revision 100)
@@ -0,0 +1,94 @@
+package com.framsticks.gui;
+
+import com.framsticks.core.Path;
+import com.framsticks.core.TreeOperations;
+import com.framsticks.gui.tree.AbstractNode;
+import com.framsticks.gui.tree.TreeNode;
+import com.framsticks.params.Access;
+import com.framsticks.params.CompositeParam;
+import com.framsticks.params.FramsClass;
+import com.framsticks.util.lang.Casting;
+
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
+
+@SuppressWarnings("serial")
+public abstract class TreePanel extends AbstractPanel {
+
+	private static final Logger log = LogManager.getLogger(TreePanel.class);
+
+	@Override
+	public void fillPanelWith(AbstractNode node) {
+		TreeNode treeNode = Casting.throwCast(TreeNode.class, node);
+
+		Path path = Path.to(treeNode.getTree(), treeNode.getTextual());
+		if (!path.isResolved()) {
+			log.error("path is not resolved: {}", path);
+			return;
+		}
+		setCurrentPath(path);
+		pullValuesFromLocalToUser(TreeOperations.bindAccess(path));
+	}
+
+	public static class Parameters {
+		public final TreeAtFrame treeAtFrame;
+		public final CompositeParam param;
+
+		/** Contained type FramsClass. */
+		public final FramsClass framsClass;
+
+		public Parameters(TreeAtFrame treeAtFrame, CompositeParam param, FramsClass framsClass) {
+			this.treeAtFrame = treeAtFrame;
+			this.param = param;
+			this.framsClass = framsClass;
+		}
+	}
+
+	protected final TreeAtFrame treeAtFrame;
+	protected final String className;
+	protected final FramsClass framsClass;
+	protected final CompositeParam param;
+	protected Path currentPath;
+
+	public TreePanel(Parameters parameters) {
+		super(parameters.treeAtFrame.getFrame());
+		this.treeAtFrame = parameters.treeAtFrame;
+		this.framsClass = parameters.framsClass;
+		this.param = parameters.param;
+		this.className = parameters.param.getContainedTypeName();
+		this.setName(parameters.param.getFramsTypeName());
+		log.debug("created panel: {}", this);
+	}
+
+	/**
+	 * @return the currentTreePath
+	 */
+	public Path getCurrentPath() {
+		return currentPath;
+	}
+
+	/**
+	 * @param currentTreePath the currentTreePath to set
+	 */
+	public void setCurrentPath(Path path) {
+		path.assureResolved();
+		this.currentPath = path;
+	}
+
+	public final TreeAtFrame getTreeAtFrame() {
+		return treeAtFrame;
+	}
+
+
+	public final String getClassName() {
+		return className;
+	}
+
+	public abstract void pullValuesFromLocalToUser(Access access);
+
+	@Override
+	public String toString() {
+		return param.getFramsTypeName() + "(" + uniqueName + ")";
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/gui/console/Console.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/console/Console.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/console/Console.java	(revision 100)
@@ -9,5 +9,6 @@
 import javax.swing.JTextPane;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import com.framsticks.communication.Connection;
@@ -24,5 +25,5 @@
 @FramsClassAnnotation
 public abstract class Console extends FrameJoinable implements JoinableParent {
-	private static final Logger log = Logger.getLogger(Console.class);
+	private static final Logger log = LogManager.getLogger(Console.class);
 
 	/**
Index: java/main/src/main/java/com/framsticks/gui/console/ConsolePainter.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/console/ConsolePainter.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/console/ConsolePainter.java	(revision 100)
@@ -3,5 +3,5 @@
 import com.framsticks.communication.File;
 import com.framsticks.util.FramsticksException;
-// import org.apache.log4j.Logger;
+// import org.apache.logging.log4j.Logger;
 
 // import java.awt.Color;
@@ -16,5 +16,5 @@
  */
 public class ConsolePainter {
-	// private static final Logger log = Logger.getLogger(ConsolePainter.class.getName());
+	// private static final Logger log = LogManager.getLogger(ConsolePainter.class.getName());
 
 	private final Document doc;
Index: java/main/src/main/java/com/framsticks/gui/controls/CheckBoxControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/CheckBoxControl.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/controls/CheckBoxControl.java	(revision 100)
@@ -7,5 +7,6 @@
 import javax.swing.JCheckBox;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import com.framsticks.params.types.BooleanParam;
@@ -14,5 +15,5 @@
 public class CheckBoxControl extends ValueControl {
 
-	private static final Logger log = Logger.getLogger(CheckBoxControl.class.getName());
+	private static final Logger log = LogManager.getLogger(CheckBoxControl.class.getName());
 
 	protected final JCheckBox checkBox;
@@ -25,5 +26,5 @@
 			@Override
 			public void actionPerformed(ActionEvent actionEvent) {
-				log.debug("change to: " + checkBox.isSelected());
+				log.debug("change to: {}", checkBox.isSelected());
 				notifyOfChange();
 			}
Index: java/main/src/main/java/com/framsticks/gui/controls/Control.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/Control.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/controls/Control.java	(revision 100)
@@ -19,5 +19,5 @@
 	public static final int LINE_HEIGHT = 36;
 
-	// private static final Logger log = Logger.getLogger(Control.class.getName());
+	// private static final Logger log = LogManager.getLogger(Control.class.getName());
 
 	protected final Param param;
Index: java/main/src/main/java/com/framsticks/gui/controls/ControlOwner.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/ControlOwner.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/controls/ControlOwner.java	(revision 100)
@@ -2,6 +2,6 @@
 
 import javax.swing.JPanel;
-import javax.swing.tree.TreePath;
 
+import com.framsticks.core.Path;
 import com.framsticks.gui.Frame;
 import com.framsticks.util.dispatching.ExceptionResultHandler;
@@ -10,5 +10,5 @@
 
 	public JPanel getPanelForControls();
-	public TreePath getCurrentTreePath();
+	public Path getCurrentPath();
 	public Frame getFrame();
 
Index: java/main/src/main/java/com/framsticks/gui/controls/EnumControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/EnumControl.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/controls/EnumControl.java	(revision 100)
@@ -3,5 +3,6 @@
 import com.framsticks.params.types.EnumParam;
 import com.framsticks.util.lang.Numbers;
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import javax.swing.*;
@@ -16,5 +17,5 @@
 	protected final JComboBox<String> list;
 
-	private static final Logger log = Logger.getLogger(EnumControl.class.getName());
+	private static final Logger log = LogManager.getLogger(EnumControl.class.getName());
 
 	public EnumControl(EnumParam enumParam) {
Index: java/main/src/main/java/com/framsticks/gui/controls/EventControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/EventControl.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/controls/EventControl.java	(revision 100)
@@ -14,5 +14,5 @@
 @SuppressWarnings("serial")
 public class EventControl extends Control {
-	// private static final Logger log = Logger.getLogger(EventControl.class.getName());
+	// private static final Logger log = LogManager.getLogger(EventControl.class.getName());
 
 	protected final JButton button;
Index: java/main/src/main/java/com/framsticks/gui/controls/ProcedureControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/ProcedureControl.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/controls/ProcedureControl.java	(revision 100)
@@ -1,5 +1,4 @@
 package com.framsticks.gui.controls;
 
-import com.framsticks.core.Tree;
 import com.framsticks.core.Path;
 import com.framsticks.gui.Frame;
@@ -10,12 +9,12 @@
 import com.framsticks.util.dispatching.ExceptionResultHandler;
 import com.framsticks.util.dispatching.FutureHandler;
-import com.framsticks.util.dispatching.RunAt;
 import com.framsticks.util.dispatching.ThrowExceptionHandler;
+import com.framsticks.util.swing.TooltipConstructor;
 
 import javax.swing.*;
 import javax.swing.border.BevelBorder;
-import javax.swing.tree.TreePath;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import java.awt.event.ActionEvent;
@@ -29,5 +28,5 @@
 public class ProcedureControl extends Control implements ControlOwner {
 
-	private static final Logger log = Logger.getLogger(ProcedureControl.class);
+	private static final Logger log = LogManager.getLogger(ProcedureControl.class);
 
 	protected final JButton procedureButton;
@@ -37,4 +36,10 @@
 	public ProcedureControl(ProcedureParam procedureParam) {
 		super(procedureParam);
+
+		this.setToolTipText(new TooltipConstructor()
+			.append("name", procedureParam.getName())
+			.append("id", procedureParam.getId())
+			.append("help", procedureParam.getHelp())
+			.build());
 
 		procedureButton = new JButton("Call");
@@ -56,5 +61,5 @@
 			public void actionPerformed(ActionEvent e) {
 
-				final Path path = getFrame().getTreeModel().convertToPath(getCurrentTreePath());
+				final Path path = getCurrentPath();
 
 				final List<Object> arguments = new LinkedList<Object>();
@@ -62,25 +67,27 @@
 					Object value = components.get(arg).getCurrentValue();
 					arguments.add(value);
-					log.debug("argument " + arg + ": " + value);
+					log.debug("argument {}: {}", arg, value);
 				}
 				//TODO FEH: make it show dialog
-				final ExceptionResultHandler handler = ThrowExceptionHandler.getInstance();
+				callProcedure(path, getParam(), arguments.toArray());
 
-				path.getTree().dispatch(new RunAt<Tree>(handler) {
-					@Override
-					protected void runAt() {
-						path.getTree().call(path, getParam(), arguments.toArray(), new FutureHandler<Object>(handler) {
-
-							@Override
-							public void result(Object result) {
-
-							}
-						});
-					}
-				});
 			}
 		});
 		this.add(procedureButton);
 
+	}
+
+	public static void callProcedure(final Path path, final ProcedureParam param, Object[] arguments) {
+		final ExceptionResultHandler handler = ThrowExceptionHandler.getInstance();
+
+		assert path.getTree().isActive();
+
+		path.getTree().call(path, param, arguments, new FutureHandler<Object>(handler) {
+
+			@Override
+			public void result(Object result) {
+
+			}
+		});
 	}
 
@@ -109,6 +116,6 @@
 
 	@Override
-	public TreePath getCurrentTreePath() {
-		return owner.getCurrentTreePath();
+	public Path getCurrentPath() {
+		return owner.getCurrentPath();
 	}
 
Index: java/main/src/main/java/com/framsticks/gui/controls/SliderControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/SliderControl.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/controls/SliderControl.java	(revision 100)
@@ -15,5 +15,6 @@
 import javax.swing.event.ChangeListener;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import com.framsticks.params.types.DecimalParam;
@@ -26,5 +27,5 @@
 public class SliderControl extends TextControl {
 
-	private static final Logger log = Logger.getLogger(SliderControl.class.getName());
+	private static final Logger log = LogManager.getLogger(SliderControl.class.getName());
 
 	protected final JSlider slider;
@@ -115,5 +116,5 @@
 					return;
 				}
-				log.trace("changing " + getParam() + " with slider: " + slider.getValue());
+				log.trace("changing {} with slider: {}", getParam(), slider.getValue());
 				changing = slider;
 				text.setText(convertFromSliderDomain(slider.getValue()).toString());
@@ -128,5 +129,5 @@
 					return;
 				}
-				log.trace("changing " + getParam() + " with text: " + text.getText());
+				log.trace("changing {} with text: {}", getParam(), text.getText());
 				changing = text;
 				Integer i = convertToSliderDomain(convertTextToNumber());
Index: java/main/src/main/java/com/framsticks/gui/controls/TextAreaControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/TextAreaControl.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/controls/TextAreaControl.java	(revision 100)
@@ -23,6 +23,7 @@
 		this.setLayout(new BorderLayout());
 		this.add(textScrollPane, BorderLayout.CENTER);
-		this.setMaximumSize(new Dimension(Integer.MAX_VALUE, LINE_HEIGHT * 3));
-		textArea.setMaximumSize(new Dimension(Integer.MAX_VALUE, LINE_HEIGHT * 3));
+		int maxSize = LINE_HEIGHT * 10;
+		this.setMaximumSize(new Dimension(Integer.MAX_VALUE, maxSize));
+		textArea.setMaximumSize(new Dimension(Integer.MAX_VALUE, maxSize));
 
 		this.revalidate();
Index: java/main/src/main/java/com/framsticks/gui/controls/ValueControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/ValueControl.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/controls/ValueControl.java	(revision 100)
@@ -1,5 +1,6 @@
 package com.framsticks.gui.controls;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import com.framsticks.params.CastFailure;
@@ -18,5 +19,5 @@
 public abstract class ValueControl extends Control {
 	private static final Logger log =
-		Logger.getLogger(ValueControl.class);
+		LogManager.getLogger(ValueControl.class);
 
 	/**
@@ -72,5 +73,5 @@
 			ReassignResult<?> res = getParam().reassign(candidate, oldValue);
 			if (res.getFlags() != 0) {
-				log.warn("filter of param " + param + " failed: " + FlagsUtil.write(SetStateFlags.class, res.getFlags(), "0"));
+				log.warn("filter of param {} failed: {}", param, FlagsUtil.write(SetStateFlags.class, res.getFlags(), "0"));
 			}
 			return res.getValue();
Index: java/main/src/main/java/com/framsticks/gui/table/Column.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/table/Column.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/table/Column.java	(revision 100)
@@ -0,0 +1,40 @@
+package com.framsticks.gui.table;
+
+
+
+import com.framsticks.params.Param;
+
+public abstract class Column {
+
+	protected final Param param;
+	protected final TableModel tableModel;
+
+	/**
+	 * @param param
+	 */
+	public Column(Param param, TableModel tableModel) {
+		this.param = param;
+		this.tableModel = tableModel;
+	}
+
+	/**
+	 * @return the param
+	 */
+	public Param getParam() {
+		return param;
+	}
+
+	public abstract Class<?> getColumnClass();
+	public abstract Object getValueAt(int rowIndex);
+
+	@Override
+	public String toString() {
+		return "column for " + param;
+	}
+
+	public abstract int setValueAt(int rowIndex, Object value);
+
+	public abstract boolean isEditable();
+
+
+}
